VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "BitBlt Form Collision Detection and animation test"
   ClientHeight    =   3600
   ClientLeft      =   1560
   ClientTop       =   1755
   ClientWidth     =   4800
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   1860
      Top             =   1260
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Activate()
Dim kd As Byte
Dim xxx As Boolean
Dim mect As Long

'set the start coordinates
xx = 170
yy = 95

'draw the start message

drawmsg = True


'declare DC values
chronoDC = CreateCompatibleDC(Me.hdc)
chronomaskDC = CreateCompatibleDC(Me.hdc)
msgDC = CreateCompatibleDC(Me.hdc)
BackGroundDC = CreateCompatibleDC(Me.hdc)
CollisionBackGroundDC = CreateCompatibleDC(Me.hdc)
cloudDC = CreateCompatibleDC(Me.hdc)
cloudmaskDC = CreateCompatibleDC(Me.hdc)

'load the object pictures into the object variables
'make sure these pictures are under app.path
chrono = LoadImage(0, App.Path & "\chronot.bmp", 0, 0, 0, &H10)
chronomask = LoadImage(0, App.Path & "\chronotmask.bmp", 0, 0, 0, &H10)
msg = LoadImage(0, App.Path & "\msg.bmp", 0, 0, 0, &H10)
BackGround = LoadImage(0, App.Path & "\bg.bmp", 0, 0, 0, &H10)
CollisionBackGround = LoadImage(0, App.Path & "\cdbg.bmp", 0, 0, 0, &H10)
cloud = LoadImage(0, App.Path & "\cloud.bmp", 0, 0, 0, &H10)
cloudmask = LoadImage(0, App.Path & "\cloudmask.bmp", 0, 0, 0, &H10)

' 'link' objects to DCs
SelectObject chronoDC, chrono
SelectObject chronomaskDC, chronomask
SelectObject msgDC, msg
SelectObject BackGroundDC, BackGround
SelectObject CollisionBackGroundDC, CollisionBackGround
SelectObject cloudDC, cloud
SelectObject cloudmaskDC, cloudmask


Me.ForeColor = RGB(255, 255, 255)

Dim cx1 As Double
Dim cx2 As Double
Dim cx3 As Double
Dim cx4 As Double
Dim cx5 As Double
Dim cx As Double

Dim cy1 As Double
Dim cy2 As Double
Dim cy3 As Double
Dim cy4 As Double
Dim cy5 As Double
Dim cy As Double

Do
'very important, clear the form
'for faster frame rates, you could
'replace this with me.refresh instead
Me.Cls
'Me.Refresh

'if a message is not visible at the time, allow the
'character to move
If drawmsg <> True Then

'if the user presses the uparrow, update the
'Y coordinate occordingly
If GetAsyncKeyState(vbKeyUp) < 0 Then
    If GetPixel(CollisionBackGroundDC, xx, yy - 1 - 8) <> RGB(0, 0, 0) Then
        yy = yy - 1
        kd = 0
    End If
End If

'if the user presses the downarrow, update the
'Y coordinate occordingly
If GetAsyncKeyState(vbKeyDown) < 0 Then
    If GetPixel(CollisionBackGroundDC, xx, yy + 1 + 8) <> RGB(0, 0, 0) Then
        yy = yy + 1
        kd = 1
    End If
End If

'if the user presses the leftarrow, update the
'X coordinate occordingly
If GetAsyncKeyState(vbKeyLeft) < 0 Then
    If GetPixel(CollisionBackGroundDC, xx - 1 - 8, yy) <> RGB(0, 0, 0) Then
        xx = xx - 1
        kd = 2
    End If
End If

'if the user presses the rightarrow, update the
'X coordinate occordingly
If GetAsyncKeyState(vbKeyRight) < 0 Then
    If GetPixel(CollisionBackGroundDC, xx + 1 + 8, yy) <> RGB(0, 0, 0) Then
        xx = xx + 1
        kd = 3
    End If
End If

End If

'if the user presses esc, end the loop
'and exit the program
If GetAsyncKeyState(vbKeyEscape) < 0 Then
GameOver = True
End If

'if the user presses enter (keycode 13) and
'the message is visible, clear the message
If drawmsg = True And GetAsyncKeyState(13) < 0 Then
    drawmsg = False
End If

BitBlt Me.hdc, 0, 0, 320, 240, BackGroundDC, 0, 0, vbSrcCopy

'draw the main character sprite
'and update its coordinates occordingly
Select Case kd
Case 0
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronomaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronoDC, 0, 0, vbSrcPaint
Case 1
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronomaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronoDC, 16, 0, vbSrcPaint
Case 2
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronomaskDC, 32, 0, vbSrcAnd
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronoDC, 32, 0, vbSrcPaint
Case 3
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronomaskDC, 48, 0, vbSrcAnd
BitBlt Me.hdc, xx - 8, yy - 8, 16, 16, chronoDC, 48, 0, vbSrcPaint
End Select


'draw the birds
If xxx = True Then

BitBlt Me.hdc, cx, cy, 16, 8, cloudmaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, cx, cy, 16, 8, cloudDC, 16, 0, vbSrcPaint

BitBlt Me.hdc, cx1 + 32, cy1, 16, 8, cloudmaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, cx1 + 32, cy1, 16, 8, cloudDC, 16, 0, vbSrcPaint

BitBlt Me.hdc, cx2 + 32, cy2, 16, 8, cloudmaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, cx2 + 32, cy2, 16, 8, cloudDC, 16, 0, vbSrcPaint

BitBlt Me.hdc, cx3 + 32, cy3, 16, 8, cloudmaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, cx3 + 32, cy3, 16, 8, cloudDC, 16, 0, vbSrcPaint

BitBlt Me.hdc, cx4 + 32, cy4, 16, 8, cloudmaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, cx4 + 32, cy4, 16, 8, cloudDC, 16, 0, vbSrcPaint

BitBlt Me.hdc, cx5 + 32, cy5, 16, 8, cloudmaskDC, 16, 0, vbSrcAnd
BitBlt Me.hdc, cx5 + 32, cy5, 16, 8, cloudDC, 16, 0, vbSrcPaint

Else

BitBlt Me.hdc, cx, cy, 16, 8, cloudmaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, cx, cy, 16, 8, cloudDC, 0, 0, vbSrcPaint

BitBlt Me.hdc, cx1 + 32, cy1, 16, 8, cloudmaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, cx1 + 32, cy1, 16, 8, cloudDC, 0, 0, vbSrcPaint

BitBlt Me.hdc, cx2 + 32, cy2, 16, 8, cloudmaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, cx2 + 32, cy2, 16, 8, cloudDC, 0, 0, vbSrcPaint

BitBlt Me.hdc, cx3 + 32, cy3, 16, 8, cloudmaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, cx3 + 32, cy3, 16, 8, cloudDC, 0, 0, vbSrcPaint

BitBlt Me.hdc, cx4 + 32, cy4, 16, 8, cloudmaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, cx4 + 32, cy4, 16, 8, cloudDC, 0, 0, vbSrcPaint

BitBlt Me.hdc, cx5 + 32, cy5, 16, 8, cloudmaskDC, 0, 0, vbSrcAnd
BitBlt Me.hdc, cx5 + 32, cy5, 16, 8, cloudDC, 0, 0, vbSrcPaint

End If

mect = mect + 1
cy = cy + 1
cy1 = cy1 + 1
cy2 = cy2 + 1
cy3 = cy3 + 1
cy4 = cy4 + 1
cy5 = cy5 + 1


'animate the birds
If mect > Rnd * 200 Then
If xxx = True Then
    xxx = False
Else
    xxx = True
End If
mect = 0
Else
End If

'set the birds to a random position
If cy >= 240 Then
Randomize
    cx = Int(Rnd * 320)
    cy = Int(Rnd * -255)
End If

If cy1 >= 240 Then
Randomize
    cy1 = Int(Rnd * -255)
    cx1 = Int(Rnd * 320)
End If

If cy2 >= 240 Then
Randomize
    cy2 = Int(Rnd * -255)
    cx2 = Int(Rnd * 320)
End If

If cy3 >= 240 Then
Randomize
    cy3 = Int(Rnd * -255)
    cx3 = Int(Rnd * 320)
End If

If cy4 >= 240 Then
Randomize
    cy4 = Int(Rnd * -255)
    cx4 = Int(Rnd * 320)
End If

If cy5 >= 240 Then
Randomize
    cy5 = Int(Rnd * -255)
    cx5 = Int(Rnd * 320)
End If

'if we want to, draw the message and its text
'draw the message last, so it is overlapping
'all other layers
If drawmsg = True Then
    BitBlt Me.hdc, 0, 0, 320, 65, msgDC, 0, 0, vbSrcPaint
    Me.Print "  Welcome to my first BitBlt example, this demonstrates"
    Me.Print "  animation, Pixel collision detection, and more. press"
    Me.Print "  Enter to close this message, click anywhere to"
    Me.Print "  Re-display this message ESC exits"
End If

DoEvents

'make a new frame, and continue to until the esc
'key is pressed
fps = fps + 1
Sleep 10

Loop Until GameOver = True

DoEvents
'delete all the memory buffers
DeleteDC chronoDC
DeleteObject chrono
DeleteDC chronomaskDC
DeleteObject chronomask
DeleteDC msgDC
DeleteObject msg
DeleteDC BackGroundDC
DeleteObject BackGround
DeleteObject CollisionBackGround
DeleteDC CollisionBackGroundDC
'unload the form
Unload Me
'end the program
End

End Sub

Private Sub Form_Click()
drawmsg = True
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'just in case
DeleteDC chronoDC
DeleteObject chrono
DeleteDC chronomaskDC
DeleteObject chronomask
DeleteDC msgDC
DeleteObject msg
DeleteDC BackGroundDC
DeleteObject BackGround
DeleteObject CollisionBackGround
DeleteDC CollisionBackGroundDC
End Sub

Private Sub Timer1_Timer()
Me.Caption = "BitBlt Example. FPS: " & fps
fps = 0
End Sub
